﻿using Sciter.Forms;
using Sciter;

namespace Demo1
{


    /// <summary>
    /// 与 FrmMain.html 关联的窗体类
    /// </summary>
    class FrmMain : Form
    {
        /// <summary>
        /// FrmMain.Html窗体类
        /// </summary>
        public FrmMain()
        {
            Width = 800;                         // 窗口宽度
            Height = 500;                        // 窗口高度
            Title = "Sciter.Forms 演示之一";     // 窗口标题
            WindowStyle = WindowStyles.Default;  // 窗口样式
            StartupPagePath = "FrmMain.html";    // 窗口界面页
        }


        /// <summary>
        /// HTML按钮对象被点击事件
        /// </summary>
        /// <param name="source"></param>
        /// <returns></returns>
        protected override bool OnButtonClick(SciterElement source)
        {
            // 获取被点击按钮的ID标记
            var id = source == null ? string.Empty : source.GetId();
            if (string.IsNullOrEmpty(id)) return false;

            // 根据不同的按钮（ID）处理相应的事务
            switch (id)
            {

                // 如果点击了“确定”
                case "but_ok":
                    ShowMessageBox("你点击了 [确定] 按钮，对不？呵呵...");
                    return true;

                // 如果点击了“关闭”
                case "but_close":
                    var ok = ShowMessageBox2("您点击了 [关闭] 按钮，真的要关闭本窗口吗？", "关闭提示");
                    if (ok) Close();
                    return true;


                // 其它无关的，交给父类处理
                default: return base.OnButtonClick(source);
            }

        }
    }
}
