﻿using Sciter.Forms;
using System;
using System.Text;
using Sciter;

namespace Demo3
{

    /*****************************************
     * 1，演示对HTML节点的赋值操作
     * 2，演示 HTML 脚本调用c#的函数
     * 3，演示 HTML 自定义对象的创建与使用
     * ***************************************/

    class FrmMain : Form
    {
        public FrmMain()
        {
            Width = 600;
            Height = 300;
            Title = "欢迎使用宇内流云开发的 Sciter.Forms 类库";
            Icon = Properties.Resources.fox1.Handle;

            //起启页数据
            StartupPage = Encoding.UTF8.GetBytes(Properties.Resources.FrmMain);

        }


        /// <summary>
        /// 登录窗实例
        /// </summary>
        private FrmLogin _frmLogin;

        /// <summary>
        /// 当前窗体创建事件（已创建实例但还没有显示）
        /// </summary>
        protected override void OnCreated()
        {
            //创建并显示登录窗口
            _frmLogin = new FrmLogin(this);
            WinApplication.Show(_frmLogin);

        }

        /// <summary>
        /// 子窗口关闭事件
        /// </summary>
        /// <param name="form"></param>
        protected override void OnChildClose(Form form)
        {
            //如果是登录窗关闭
            if (form != null && _frmLogin == form)
            {
                //如果用户在登录窗登录成功，就显示本窗口（主窗体）
                //如果没有登录成功就关闭了登录窗，那么也将本窗口关闭掉（主窗体关闭意味着程序退出）

                if (_frmLogin.Login)
                    WinApplication.Show(this);
                else
                    Close();
            }
        }

        /// <summary>
        /// 用户名，调用者赋值
        /// </summary>
        public string UsrNames { get; set; } = "王哥李哥";


        /// <summary>
        /// HTML DOCUMENT 加载完成的事件
        /// </summary>
        /// <returns></returns>
        protected override void OnReady(SciterElement se)
        {

            // ** 正文加载完成后，可以主动发起操作了

            // 下面演示如何给某html对象赋新值
            //======================================


            // 获取Html页中规划的用显示用户名的元素
            var namebox = GetElementById("usrnm");
            if (namebox == null) return;

            // 为显示用户名的 DIV元素设置新的内容
            namebox.Value = new SciterValue(UsrNames + " 哥俩好：");
            // namebox.Update(); //不必频繁刷新
        }


        /// <summary>
        /// 提供给HTML脚本调用的函数（脚本通过 “view.方法名” 调用窗体类的C#方法）
        /// </summary>
        /// <returns></returns>
        /// <param name="src">发起调用的对象（可能为NULL）</param>
        /// <param name="args">脚本调用时的参数列表</param>
        public SciterValue ViewData(SciterElement src, SciterValue[] args)
        {
            var tm = (DateTime.Now.ToString("yyy-MM-dd HH:mm:ss"));
            return new SciterValue(tm);
        }

    }
}
